//API
var Vector3={};
var pow=Math.pow,cos=Math.cos,sin=Math.sin,sqrt=Math.sqrt,max=Math.max,acos=Math.acos;

function r(v,d){
    return Number(Math.round(v+'e'+d)+'e-'+d);
}

Vector3.new=function(x,y,z){
    let self={}
    self.x=x||0;
    self.y=y||0;
    self.z=z||0;

    self.sub=function(a){
        if(!a.__type || a.__type!="Vector3"){Error("Not a valid Vector3");}
        return Vector3.new(self.x-a.x,self.y-a.y,self.z-a.z);
    };

    self.add=function(a){
        if(!a.__type || a.__type!="Vector3"){Error("Not a valid Vector3");}
        return Vector3.new(self.x+a.x,self.y+a.y,self.z+a.z);
    };

    self.mult=function(a){
        if(!a.__type && a.__type!="Vector3" && typeof(a)!="number"){Error("Not a valid Vector3/Number");}
        if(a.__type){
            return Vector3.new(self.x*a.x,self.y*a.y,self.z*a.z);
        }else{ //Divider is a numeral
            return Vector3.new(self.x*a,self.y*a,self.z*a);
        }
    };

    self.div=function(a){
        if(!a.__type && a.__type!="Vector3" && typeof(a)!="number"){Error("Not a valid Vector3/Number");}
        if(a.__type){
            return Vector3.new(self.x/a.x,self.y/a.y,self.z/a.z);
        }else{ //Divider is a numeral
            return Vector3.new(self.x/a,self.y/a,self.z/a);
        }
    };

    self.Dot=function(a){
        return self.x*a.x+self.y*a.y+self.z*a.z;
    };

    self.Cross=function(a){
        return Vector3.new(
            self.y*a.z-a.y*self.z,
            self.z*a.x-a.z*self.x,
            self.x*a.y-a.x*self.y
        );
    };

    self.Lerp=function(a,t){
        return self.mult(1-t).add(a.mult(t));
    }

    self.Compare=function(a){
        if(a.x==undefined || a.y==undefined || a.z==undefined){Error("Not a valid comparison object for Vector3");}
        return a.x==self.x && a.y==self.y && a.z==self.z;
    }

    self.Round=function(d){
        return Vector3.new(r(self.x,d),r(self.y,d),r(self.z,d));
    }

    self.Rotate=function(r){
        //Rotate X Axis
        let ny=y*Math.cos(rx)-z*Math.sin(rx)
        let nz=y*Math.sin(rx)+z*Math.cos(rz)
        //Rotate Y Axis
        let nx=x*Math.cos(ry)-nz*Math.sin(ry)
        nz=x*Math.sin(ry)+nz*Math.cos(ry)
        //Rotate Z Axis
        nx=nx*Math.cos(rz)-ny*Math.sin(rz)
        ny=nx*Math.sin(rz)+ny*Math.cos(rz)

        return Vector3.new(nx,ny,nz);
    }

    self.RotateLocalSpace=function(r,p){
        let nP=self.sub(p);
        nP=nP.Rotate(r);
        return nP.add(p);
    }

    self.toString=function(){return self.x+","+self.y+","+self.z;};

    self.magnitude=sqrt(self.Dot(self));
    self.unit=function(){
        return self.div(self.magnitude);
    };

    return self;
}

module.exports=Vector3;
